Public Class ShapesForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        components = New System.ComponentModel.Container()
        Me.Text = "ShapesForm"
    End Sub

#End Region



    Private Sub ShapesForm_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles MyBase.Paint

        Dim g As Graphics = e.Graphics
        Dim x As Integer = 0
        Dim y As Integer = 0
        Dim width As Integer = Me.ClientRectangle.Width / 3
        Dim height As Integer = Me.ClientRectangle.Height / 3
        Dim blackBrush As Brush = Brushes.Black
        Dim fillBrush As Brush = Brushes.Gray
        Dim whitePen As Pen = Pens.White
        Dim format As StringFormat = New StringFormat()
        format.Alignment = StringAlignment.Center
        format.LineAlignment = StringAlignment.Center

        Dim pen As Pen = New Pen(Color.Red, 4)
        g.DrawArc(pen, x + 10, y + 10, width - 20, height - 20, 180, 180)
        g.DrawString("Arc", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.DrawBezier(pen, New Point(x + 10, y + height - 20), New Point(x + width - 20, y + height - 20), New Point(x + 10, y + 10), New Point(x + width - 20, y + 10))
        g.DrawString("Bezier", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.FillClosedCurve(fillBrush, New PointF() {New PointF(x + 10, y + height - 20), New PointF(x + width - 20, y + height - 20), New PointF(x + 10, y + 10), New PointF(x + width - 20, y + 10)})
        g.DrawClosedCurve(pen, New PointF() {New PointF(x + 10, y + height - 20), New PointF(x + width - 20, y + height - 20), New PointF(x + 10, y + 10), New PointF(x + width - 20, y + 10)})
        g.DrawString("Closed Curve", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.DrawCurve(pen, New PointF() {New PointF(x + 10, y + height - 20), New PointF(x + width - 20, y + height - 20), New PointF(x + 10, y + 10), New PointF(x + width - 20, y + 10)})
        g.DrawString("Curve", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.FillEllipse(fillBrush, x + 10, y + 10, width - 20, height - 20)
        g.DrawEllipse(pen, x + 10, y + 10, width - 20, height - 20)
        g.DrawString("Ellipse", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.DrawLines(pen, New PointF() {New PointF(x + 10, y + height - 20), New PointF(x + width - 20, y + height - 20), New PointF(x + 10, y + 10), New PointF(x + width - 20, y + 10)})
        g.DrawString("Lines", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.FillPie(fillBrush, x + 10, y + 10, width - 20, height - 20, 180, 180)
        g.DrawPie(pen, x + 10, y + 10, width - 20, height - 20, 180, 180)
        g.DrawString("Pie", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.FillPolygon(fillBrush, New PointF() {New PointF(x + 10, y + height - 20), New PointF(x + width - 20, y + height - 20), New PointF(x + 10, y + 10), New PointF(x + width - 20, y + 10)})
        g.DrawPolygon(pen, New PointF() {New PointF(x + 10, y + height - 20), New PointF(x + width - 20, y + height - 20), New PointF(x + 10, y + 10), New PointF(x + width - 20, y + 10)})
        g.DrawString("Polygon", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)

        g.FillRectangle(fillBrush, x + 10, y + 10, width - 20, height - 20)
        g.DrawRectangle(pen, x + 10, y + 10, width - 20, height - 20)
        g.DrawString("Rectangle", Me.Font, blackBrush, New RectangleF(x, y, width, height), format)
        x = IIf(x > Me.ClientRectangle.Width - 2 * width, 0, x + width)
        y = IIf(x = 0, y + height, y)
          End Sub
End Class
